      PROGRAM MAINFAKE
C     *****************



C Here come calls to your programs, just running in this case.
      CALL TESTES

      END


      SUBROUTINE TESTES
C     *****************
      IOUT=15
      OPEN(IOUT,FILE="./flap.dat",STATUS='OLD')
      NEVTES=5 
 
      DO 300 IEV=1,NEVTES

         CALL PSEUDOEVENT(IOUT,IEV)            !  pseudo_generator

         IF (IEV.NE.NEVTES) CALL CONTI(IOUT)
  300 CONTINUE
        CALL ENDGAME(IOUT)                 ! to inform that there is the end
      RETURN
      END
      
      SUBROUTINE PSEUDOEVENT(IOUT,IEV)
C     ======================
C     this is template for your generator writing format to the file.
C     it can be in any language.
      DIMENSION  XPB1(4),XPB2(4),AQF1(4),AQF2(4)
      DIMENSION   AQF3(4),AQF4(4) ,AQF5(4),AQF6(4)  ,AQF7(4),AQF8(4) 

C      IN FINAL STATE THERE ARE N PARTICLES .... 
        N=6

C       IEV is used to make the events different! In reality it 
C           is not necessary, but here otherwise all events would be identical. 
      
!      Some of them may be dummy

C HERE COME THEIR IDENTIFIERS, ACCORDINGLY TO PARTICLE DATA GROUP CONVENTIONS
C JUST IN CASE WE FILL VALUES FOR 8 FINAL STATESBUT ONLY FIRST N WILL BE USED.

C beams ...
        KFB1= 11
        KFB2=-11

C final states ...

        IDF1= 13
        IDF2=-13
        IDF3= 12
        IDF4=-12
        IDF5= 14
        IDF6=-14
        IDF7= 15
        IDF8=-15

C MOMENTA OF THE BEAMS:
        XPB1(1)= 0.
        XPB2(1)= 0.
        XPB1(2)= 0.
        XPB2(2)= 0.
        XPB1(3)= 5.*N
        XPB2(3)=-5.*N 
        XPB1(4)= 5.*N
        XPB2(4)= 5.*N 

C MOMENTA OF THE FIRST PAIR OF FERMIONS:
        AQF1(1)= 0.
        AQF2(1)= 0.
        AQF1(2)= 0.
        AQF2(2)= 0.
        AQF1(3)= 10.+IEV*0.01
        AQF2(3)=-10.-IEV*0.01
        AQF1(4)= 10.+IEV*0.01
        AQF2(4)= 10.+IEV*0.01

C MOMENTA OF THE SECOND PAIR OF FERMIONS:
        AQF3(1)= 10.-IEV*0.01
        AQF4(1)=-10.+IEV*0.01
        AQF3(2)= 0.
        AQF4(2)= 0.
        AQF3(3)= 0.
        AQF4(3)= 0.
        AQF3(4)= 10.-IEV*0.01
        AQF4(4)= 10.-IEV*0.01

C MOMENTA OF THE THIRD PAIR OF FERMIONS:
        AQF5(1)= 0.
        AQF6(1)= 0.
        AQF5(2)= 10.
        AQF6(2)=-10.
        AQF5(3)= 0.
        AQF6(3)= 0.
        AQF5(4)= 10.
        AQF6(4)= 10.

C MOMENTA OF THE FOURTH PAIR OF FERMIONS:
        AQF7(1)= 5.
        AQF8(1)=-5.
        AQF7(2)= 5.
        AQF8(2)=-5.
        AQF7(3)= 0.
        AQF8(3)= 0.
        AQF7(4)= 10.
        AQF8(4)= 10.
        

C weight of the event, at present not yet used by mc-tester.
      WT=1.0       
      CALL TOWRITI(IOUT,N,KFB1,KFB2,
     $ IDF1,IDF2,IDF3,IDF4,IDF5,IDF6,IDF7,IDF8,
     $ XPB1,XPB2,AQF1,AQF2,AQF3,AQF4,AQF5,AQF6,AQF7,AQF8,WT)

      END


      SUBROUTINE TOWRITI(IOUT,N,KFB1,KFB2,
     $ IDF1,IDF2,IDF3,IDF4,IDF5,IDF6,IDF7,IDF8,
     $ XPB1,XPB2,AQF1,AQF2,AQF3,AQF4,AQF5,AQF6,AQF7,AQF8,WT)
C     ===================================================
C     THIS IS THE ROUTINE YOU WILL USE:
C     N             - number of particles in final state
C     KFB1,KFB2     - beam identifiers
C     IDF1,IDF2,... - identifiers of FS particles 
C     XPB1,XPB2,... - beam four momenta
C     AQF1,AQF2,... - final state partcls four momenta
C     IDFn,AQFn     - for n.GT.N are dummy
C     ===================================================
      DIMENSION  XPB1(4),XPB2(4),AQF1(4),AQF2(4)
      DIMENSION  AQF3(4),AQF4(4),AQF5(4),AQF6(4),AQF7(4),AQF8(4) 

      write(IOUT,1) 'event'
      write(IOUT,2) N,'number of particles'
      write(IOUT,4) WT,'event weight      '
      write(IOUT,3) KFB1,XPB1     
      write(IOUT,3) KFB2,XPB2     
      write(IOUT,3) IDF1,AQF1
      IF (N.EQ.1) RETURN
      write(IOUT,3) IDF2,AQF2
      IF (N.EQ.2) RETURN
      write(IOUT,3) IDF3,AQF3
      IF (N.EQ.3) RETURN
      write(IOUT,3) IDF4,AQF4
      IF (N.EQ.4) RETURN
      write(IOUT,3) IDF5,AQF5
      IF (N.EQ.5) RETURN
      write(IOUT,3) IDF6,AQF6
      IF (N.EQ.6) RETURN
      write(IOUT,3) IDF7,AQF7
      IF (N.EQ.7) RETURN
      write(IOUT,3) IDF8,AQF8
      IF (N.EQ.8) RETURN
 1    FORMAT(1x,a5)
 2    FORMAT(1x,I3,a20)
 4    FORMAT(1x,E16.9,a20)
 3    FORMAT(1x,I3,4(1x,E16.9))
      END


      SUBROUTINE ENDGAME(IOUT)

      write(IOUT,1) 'endss'

 1    FORMAT(1x,a5)

      END

      SUBROUTINE CONTI(IOUT)

      write(IOUT,1) 'conti'

 1    FORMAT(1x,a5)

      END

