      PROGRAM TESTERDEM
C     *****************
      COMMON /INOUT/ INUT,IOUT
      IOUT=15
      OPEN(IOUT,FILE="./flap.dat")

C===============================
C initialization of MC-TESTER  =
C===============================
C we'll use HEPEVT: 
      CALL MCSETUP(0,0)
C decay of tau- PDG=15
!      CALL MCSETUP(2,15) 
      CALL MCSETUP(2,100) 
C  generation stage (generator id): 1
      CALL MCSETUP(1,1)
C Histograms set-up:
C 120 bins per histogram     
      CALL MCSETUPHBINS(120)
C default minimum bin value is 0.0D0
      CALL MCSETUPHMIN(0.0D0)
C default maximum bin value is 90.0D0 (1.5 times cms energy for w-shop.
      CALL MCSETUPHMAX(90D0)

C execute initialization of  MC-Tester
      CALL MCTEST(-1)
C======================================
C end of initialization of MC-TESTER  =
C======================================

C Here come calls to your programs, just running in this case.
      CALL TESTES

C finalization of MC-TESTER actions:
      CALL MCTEST(1)
      END


      SUBROUTINE TESTES
C     *****************
      character*5 status,zmn1
      DIMENSION RR(1)
      NEVTES1= 0 !!! 1 000 
      NEVTES2=100 000 000
      AWT=0
      IREPIMAX=0
      zmn1='conti'
      write(*,*) 'here is >>>> TESTES <<<<<<:'
      write(*,*) 'We take NEVTES1= ',NEVTES1,' events to find average wt'
      write(*,*) 'and maximum NEVTES2=',NEVTES2,' events for searching'
      write(*,*) 'normally run will be stopped earlier by flag from fifo-data'
      write(*,*) '1) NEVTES1=0 means that WT=1 will be assumed'
      write(*,*) '2) For NEVTES1.gt.0 common maximal weight for all f.s. channels'
      write(*,*) '   will be calculated, this may cause troubles. Prudence !!'
C first loop is to calculate average weight:
C =========================================

      DO  IEV=1,NEVTES1

         CALL PSEUDOEVENT(status,WT) !  pseudo_generator 
C at present event weight WT is not yet used by MC-tester.
         IF (IEV.eq.1) write(*,*) 'run for weighted events'
         IF (IEV.eq.1) write(*,*) 'primitive solution !!'
         IF (IEV.le.3) call phodmpts ! how the hepevt is filled ?
         AWT=AWT+WT
!         CALL MCTEST(0)              ! MC-TESTER is called
!         IF(status.eq.zmn1)  write(*,*) 'conti=',status
!         IF(status.ne.zmn1)  write(*,*)'ne conti=',status
         IF(status.ne.zmn1) goto 320
      ENDDO

      IF (NEVTES1.NE.0) THEN
        AWT=AWT/NEVTES1
      ELSE
        AWT=1.
      ENDIF
C ============================================================
C second loop is to explore events with MC-tester:           =
C for weighted events they may be rejected or duplicated     =
C depending on the ratio of their WT with respect to average =
C AWT calculated from first NEVTES1 events.                  =
C ============================================================
      DO  IEV=1,NEVTES2

         CALL PSEUDOEVENT(status,WT) !  pseudo_generator
C at present event weight WT is not yet used by MC-tester.
         IF (IEV.le.3) call phodmpts ! how the hepevt is filled ?
         IREPI=WT/AWT
         DO K=1,IREPI
           CALL MCTEST(0)              ! MC-TESTER is called
         ENDDO
         WTX=WT-IREPI*AWT
         IREPIMAX=MAX(IREPIMAX,IREPI)
         CALL RANMAR(RR,1)
         IF (WTX/AWT.GT.RR(1))  CALL MCTEST(0)  
!         IF(status.eq.zmn1)  write(*,*) 'conti=',status
!         IF(status.ne.zmn1)  write(*,*)'ne conti=',status
         IF(status.ne.zmn1) goto 320
      ENDDO
 320  CONTINUE

      IF (IREPIMAX.GT.2) THEN
        write(*,*) '  '
        write(*,*) 'Warning from >>>> TESTES <<<<<<:'
        write(*,*) 'cloning count reached : ',  IREPIMAX
        write(*,*) '1) If it is significantly larger than 1 then'
        write(*,*) '   SDP of MC-tester will be wrong'
        write(*,*) '2) If it is non-negligible in comparison with'
        write(*,*) '   no of generated events there is serious problem' 
        write(*,*) '   with tested generator' 
      ENDIF

      RETURN
      END
      
      SUBROUTINE PSEUDOEVENT(status,WT)
C     ======================
      COMMON /INOUT/ INUT,IOUT
C     This PSEUDOEVENT can need fill of HEPEVT with up to 8 final
C     state fermions. The TOHEPI routine should work with any
C     of these cases, as well as with your programs 
      DIMENSION  XPB1(4),XPB2(4),AQF1(4),AQF2(4)
      DIMENSION   AQF3(4),AQF4(4) ,AQF5(4),AQF6(4)  ,AQF7(4),AQF8(4) 
      character*5 label,status
C      IN FINAL STATE THERE ARE N PARTICLES .... 

      read(IOUT,1) label
      read(IOUT,2) N
      read(IOUT,4) WT
      read(IOUT,3) KFB1,XPB1     
      read(IOUT,3) KFB2,XPB2     
      read(IOUT,3) IDF1,AQF1
      IF (N.EQ.1) goto 7
      read(IOUT,3) IDF2,AQF2
      IF (N.EQ.2)  goto 7
      read(IOUT,3) IDF3,AQF3
      IF (N.EQ.3)  goto 7
      read(IOUT,3) IDF4,AQF4
      IF (N.EQ.4)  goto 7
      read(IOUT,3) IDF5,AQF5
      IF (N.EQ.5)  goto 7
      read(IOUT,3) IDF6,AQF6
       IF (N.EQ.6)  goto 7
      read(IOUT,3) IDF7,AQF7
      IF (N.EQ.7)  goto 7
      read(IOUT,3) IDF8,AQF8
      IF (N.EQ.8)  goto 7
 7    continue
      read(IOUT,1) status
   

!      Some of them may be dummy
 1    FORMAT(1x,a5)
 2    FORMAT(1x,I3)
 4    FORMAT(1x,E16.9)
 3    FORMAT(1x,I3,4(1x,E16.9))

!      CALL TOWRITI(0,N,KFB1,KFB2,
!     $ IDF1,IDF2,IDF3,IDF4,IDF5,IDF6,IDF7,IDF8,
!     $ XPB1,XPB2,AQF1,AQF2,AQF3,AQF4,AQF5,AQF6,AQF7,AQF8)

      CALL TOHEPI(N,KFB1,KFB2,
     $ IDF1,IDF2,IDF3,IDF4,IDF5,IDF6,IDF7,IDF8,
     $ XPB1,XPB2,AQF1,AQF2,AQF3,AQF4,AQF5,AQF6,AQF7,AQF8)

      END


      SUBROUTINE TOWRITI(IOUT,N,KFB1,KFB2,
     $ IDF1,IDF2,IDF3,IDF4,IDF5,IDF6,IDF7,IDF8,
     $ XPB1,XPB2,AQF1,AQF2,AQF3,AQF4,AQF5,AQF6,AQF7,AQF8)
C     ===================================================
C     THIS IS THE ROUTINE YOU WILL USE:
C     N             - number of particles in final state
C     KFB1,KFB2     - beam identifiers
C     IDF1,IDF2,... - identifiers of FS particles 
C     XPB1,XPB2,... - beam four momenta
C     AQF1,AQF2,... - final state partcls four momenta
C     IDFn,AQFn     - for n.GT.N are dummy
C     ===================================================
      DIMENSION  XPB1(4),XPB2(4),AQF1(4),AQF2(4)
      DIMENSION  AQF3(4),AQF4(4),AQF5(4),AQF6(4),AQF7(4),AQF8(4) 

      write(IOUT,1) 'event'
      write(IOUT,2) N,'number of particles'
      write(IOUT,3) KFB1,XPB1     
      write(IOUT,3) KFB2,XPB2     
      write(IOUT,3) IDF1,AQF1
      IF (N.EQ.1) RETURN
      write(IOUT,3) IDF2,AQF2
      IF (N.EQ.2) RETURN
      write(IOUT,3) IDF3,AQF3
      IF (N.EQ.3) RETURN
      write(IOUT,3) IDF4,AQF4
      IF (N.EQ.4) RETURN
      write(IOUT,3) IDF5,AQF5
      IF (N.EQ.5) RETURN
      write(IOUT,3) IDF6,AQF6
      IF (N.EQ.6) RETURN
      write(IOUT,3) IDF7,AQF7
      IF (N.EQ.7) RETURN
      write(IOUT,3) IDF8,AQF8
      IF (N.EQ.8) RETURN
 1    FORMAT(1x,a5)
 2    FORMAT(1x,I3,a20)
 3    FORMAT(1x,I3,4(1x,E16.9))
      END

      SUBROUTINE TOHEPI(N,KFB1,KFB2,
     $ IDF1,IDF2,IDF3,IDF4,IDF5,IDF6,IDF7,IDF8,
     $ XPB1,XPB2,AQF1,AQF2,AQF3,AQF4,AQF5,AQF6,AQF7,AQF8)
C     ===================================================
C     THIS IS THE ROUTINE YOU WILL USE:
C     N             - number of particles in final state
C     KFB1,KFB2     - beam identifiers
C     IDF1,IDF2,... - identifiers of FS particles 
C     XPB1,XPB2,... - beam four momenta
C     AQF1,AQF2,... - final state partcls four momenta
C     IDFn,AQFn     - for n.GT.N are dummy
C     ===================================================
      DIMENSION  XPB1(4),XPB2(4),AQF1(4),AQF2(4)
      DIMENSION  AQF3(4),AQF4(4),AQF5(4),AQF6(4),AQF7(4),AQF8(4) 

C CALCULATING MASSES AND WRITING DOWN TO EVENT RRRECORD: BEAMS:

      AMEL=SQRT(ABS(XPB1(4)**2-XPB1(3)**2-XPB1(2)**2-XPB1(1)**2))   
      CALL FYLHEP(  1,3, KFB1,0,0,0,0,XPB1, AMEL,.TRUE.)

      AMEL=SQRT(ABS(XPB2(4)**2-XPB2(3)**2-XPB2(2)**2-XPB2(1)**2)) 
      CALL FYLHEP(  2,3, KFB2,0,0,0,0,XPB2, AMEL,.TRUE.)

C=============================================================
C THE SAME FOR FINAL STATES (UP TO N ENTRY)

      AMTAU=SQRT(ABS(AQF1(4)**2-AQF1(3)**2-AQF1(2)**2-AQF1(1)**2))
      CALL FYLHEP(  3,1, IDF1,1,2,0,0,AQF1,AMTAU,.TRUE.)

      AMTAU=SQRT(ABS(AQF2(4)**2-AQF2(3)**2-AQF2(2)**2-AQF2(1)**2))
      CALL FYLHEP(  4,1,IDF2,1,2,0,0,AQF2,AMTAU,.TRUE.)
      IF(N.EQ.2) RETURN

      AMTAU=SQRT(ABS(AQF3(4)**2-AQF3(3)**2-AQF3(2)**2-AQF3(1)**2))
      CALL FYLHEP(  5,1, IDF3,1,2,0,0,AQF3,AMTAU,.TRUE.)
      IF(N.EQ.3) RETURN

      AMTAU=SQRT(ABS(AQF4(4)**2-AQF4(3)**2-AQF4(2)**2-AQF4(1)**2))
      CALL FYLHEP(  6,1,IDF4,1,2,0,0,AQF4,AMTAU,.TRUE.)
      IF(N.EQ.4) RETURN

      AMTAU=SQRT(ABS(AQF5(4)**2-AQF5(3)**2-AQF5(2)**2-AQF5(1)**2))
      CALL FYLHEP(  7,1, IDF5,1,2,0,0,AQF5,AMTAU,.TRUE.)
      IF(N.EQ.5) RETURN

      AMTAU=SQRT(ABS(AQF6(4)**2-AQF6(3)**2-AQF6(2)**2-AQF6(1)**2))
      CALL FYLHEP(  8,1,IDF6,1,2,0,0,AQF6,AMTAU,.TRUE.)
      IF(N.EQ.6) RETURN

      AMTAU=SQRT(ABS(AQF7(4)**2-AQF7(3)**2-AQF7(2)**2-AQF7(1)**2))
      CALL FYLHEP(  9,1, IDF7,1,2,0,0,AQF7,AMTAU,.TRUE.)
      IF(N.EQ.7) RETURN

      AMTAU=SQRT(ABS(AQF8(4)**2-AQF8(3)**2-AQF8(2)**2-AQF8(1)**2))
      CALL FYLHEP( 10,1,IDF8,1,2,0,0,AQF8,AMTAU,.TRUE.)


      END


      SUBROUTINE PHODMPTS
C.----------------------------------------------------------------------
C.
C.    PHOTOS:   PHOton radiation in decays event DuMP routine
C.
C.    Purpose:  Print event record.
C.
C.    Input Parameters:   Common /HEPEVT/
C.
C.    Output Parameters:  None
C.
C.    Author(s):  B. van Eijk                     Created at:  05/06/90
C.                                                Last Update: 05/06/90
C.
C.----------------------------------------------------------------------
C      IMPLICIT NONE
      DOUBLE PRECISION  SUMVEC(5)
      INTEGER I,J
C this is the hepevt class in old style. No d_h_ class pre-name
      INTEGER NMXHEP
      PARAMETER (NMXHEP=4000)
      REAL*8  phep,  vhep ! to be real*4/ *8  depending on host
      INTEGER nevhep,nhep,isthep,idhep,jmohep,
     $        jdahep
      COMMON /hepevt/
     $      nevhep,               ! serial number
     $      nhep,                 ! number of particles
     $      isthep(nmxhep),   ! status code
     $      idhep(nmxhep),    ! particle ident KF
     $      jmohep(2,nmxhep), ! parent particles
     $      jdahep(2,nmxhep), ! childreen particles
     $      phep(5,nmxhep),   ! four-momentum, mass [GeV]
     $      vhep(4,nmxhep)    ! vertex [mm]
* ----------------------------------------------------------------------
      LOGICAL qedrad
      COMMON /phoqed/ 
     $     qedrad(nmxhep)    ! Photos flag
* ----------------------------------------------------------------------
      SAVE hepevt,phoqed



      INTEGER PHLUN
      COMMON/PHOLUN/PHLUN
      DO 10 I=1,5
   10 SUMVEC(I)=0.
C--
C--   Print event number...
      WRITE(PHLUN,9000)
      WRITE(PHLUN,9010) NEVHEP
      WRITE(PHLUN,9080)
      WRITE(PHLUN,9020)
      DO 30 I=1,NHEP
C--
C--   For 'stable particle' calculate vector momentum sum
        IF (JDAHEP(1,I).EQ.0) THEN
          DO 20 J=1,4
   20     SUMVEC(J)=SUMVEC(J)+PHEP(J,I)
          IF (JMOHEP(2,I).EQ.0) THEN
            WRITE(PHLUN,9030) I,IDHEP(I),JMOHEP(1,I),(PHEP(J,I),J=1,5)
          ELSE
            WRITE(PHLUN,9040) I,IDHEP(I),JMOHEP(1,I),JMOHEP(2,I),(PHEP
     &      (J,I),J=1,5)
          ENDIF
        ELSE
          IF (JMOHEP(2,I).EQ.0) THEN
            WRITE(PHLUN,9050) I,IDHEP(I),JMOHEP(1,I),JDAHEP(1,I),
     &      JDAHEP(2,I),(PHEP(J,I),J=1,5)
          ELSE
            WRITE(PHLUN,9060) I,IDHEP(I),JMOHEP(1,I),JMOHEP(2,I),
     &      JDAHEP(1,I),JDAHEP(2,I),(PHEP(J,I),J=1,5)
          ENDIF
        ENDIF
   30 CONTINUE
      SUMVEC(5)=SQRT(SUMVEC(4)**2-SUMVEC(1)**2-SUMVEC(2)**2-
     &SUMVEC(3)**2)
      WRITE(PHLUN,9070) (SUMVEC(J),J=1,5)
      RETURN
 9000 FORMAT(1H0,80('='))
 9010 FORMAT(1H ,29X,'Event No.:',I10)
 9020 FORMAT(1H0,1X,'Nr',3X,'Type',3X,'Parent(s)',2X,'Daughter(s)',6X,
     &'Px',7X,'Py',7X,'Pz',7X,'E',4X,'Inv. M.')
 9030 FORMAT(1H ,I4,I7,3X,I4,9X,'Stable',2X,5F9.2)
 9040 FORMAT(1H ,I4,I7,I4,' - ',I4,5X,'Stable',2X,5F9.2)
 9050 FORMAT(1H ,I4,I7,3X,I4,6X,I4,' - ',I4,5F9.2)
 9060 FORMAT(1H ,I4,I7,I4,' - ',I4,2X,I4,' - ',I4,5F9.2)
 9070 FORMAT(1H0,23X,'Vector Sum: ', 5F9.2)
 9080 FORMAT(1H0,6X,'Particle Parameters')
      END

      SUBROUTINE FYLHEP(N,IST,ID,JMO1,JMO2,JDA1,JDA2,P4,PINV,PHFLAG)
C ----------------------------------------------------------------------
C this subroutine fills one entry into the HEPEVT common
C and updates the information for affected mother entries
C
C written by Martin W. Gruenewald (91/01/28)
C
C     called by : ZTOHEP,BTOHEP,DWLUxy
C ----------------------------------------------------------------------
C
C this is the hepevt class in old style. No d_h_ class pre-name
      INTEGER NMXHEP
      PARAMETER (NMXHEP=4000)
      REAL*8  phep,  vhep ! to be real*4/ *8  depending on host
      INTEGER nevhep,nhep,isthep,idhep,jmohep,
     $        jdahep
      COMMON /hepevt/
     $      nevhep,               ! serial number
     $      nhep,                 ! number of particles
     $      isthep(nmxhep),   ! status code
     $      idhep(nmxhep),    ! particle ident KF
     $      jmohep(2,nmxhep), ! parent particles
     $      jdahep(2,nmxhep), ! childreen particles
     $      phep(5,nmxhep),   ! four-momentum, mass [GeV]
     $      vhep(4,nmxhep)    ! vertex [mm]
* ----------------------------------------------------------------------
      LOGICAL qedrad
      COMMON /phoqed/ 
     $     qedrad(nmxhep)    ! Photos flag
* ----------------------------------------------------------------------
      SAVE hepevt,phoqed



C      PARAMETER (NMXHEP=2000)
C      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
C     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
C      SAVE  /HEPEVT/
C      COMMON/PHOQED/QEDRAD(NMXHEP)
C      LOGICAL QEDRAD
C      SAVE /PHOQED/
      LOGICAL PHFLAG
C
      REAL*4  P4(4)
C
C check address mode
      IF (N.EQ.0) THEN
C
C append mode
        IHEP=NHEP+1
      ELSE IF (N.GT.0) THEN
C
C absolute position
        IHEP=N
      ELSE
C
C relative position
        IHEP=NHEP+N
      END IF
C
C check on IHEP
      IF ((IHEP.LE.0).OR.(IHEP.GT.NMXHEP)) RETURN
C
C add entry
      NHEP=IHEP
      ISTHEP(IHEP)=IST
      IDHEP(IHEP)=ID
      JMOHEP(1,IHEP)=JMO1
      IF(JMO1.LT.0)JMOHEP(1,IHEP)=JMOHEP(1,IHEP)+IHEP
      JMOHEP(2,IHEP)=JMO2
      IF(JMO2.LT.0)JMOHEP(2,IHEP)=JMOHEP(2,IHEP)+IHEP
      JDAHEP(1,IHEP)=JDA1
      JDAHEP(2,IHEP)=JDA2
C
      DO I=1,4
        PHEP(I,IHEP)=P4(I)
C
C KORAL-B and KORAL-Z do not provide vertex and/or lifetime informations
        VHEP(I,IHEP)=0.0
      END DO
      PHEP(5,IHEP)=PINV
C FLAG FOR PHOTOS...
      QEDRAD(IHEP)=PHFLAG
C
C update process:
      DO IP=JMOHEP(1,IHEP),JMOHEP(2,IHEP)
        IF(IP.GT.0)THEN
C
C if there is a daughter at IHEP, mother entry at IP has decayed
          IF(ISTHEP(IP).EQ.1)ISTHEP(IP)=2
C
C and daughter pointers of mother entry must be updated
          IF(JDAHEP(1,IP).EQ.0)THEN
            JDAHEP(1,IP)=IHEP
            JDAHEP(2,IP)=IHEP
          ELSE
            JDAHEP(2,IP)=MAX(IHEP,JDAHEP(2,IP))
          END IF
        END IF
      END DO
C
      RETURN
      END



      SUBROUTINE RANMAR(RVEC,LENV)
C ----------------------------------------------------------------------
C<<<<<FUNCTION RANMAR(IDUMM)
C CERNLIB V113, VERSION WITH AUTOMATIC DEFAULT INITIALIZATION
C     Transformed to SUBROUTINE to be as in CERNLIB
C     AM.Lutz   November 1988, Feb. 1989
C
C!Universal random number generator proposed by Marsaglia and Zaman
C in report FSU-SCRI-87-50
C        modified by F. James, 1988 and 1989, to generate a vector
C        of pseudorandom numbers RVEC of length LENV, and to put in
C        the COMMON block everything needed to specify currrent state,
C        and to add input and output entry points RMARIN, RMARUT.
C
C     Unique random number used in the program
C ----------------------------------------------------------------------
      COMMON / INOUTR / INUT,IOUT
      DIMENSION RVEC(*)
      COMMON/RASET1/U(97),C,I97,J97
      PARAMETER (MODCNS=1000000000)
      DATA NTOT,NTOT2,IJKL/-1,0,0/
C
      IF (NTOT .GE. 0)  GO TO 50
C
C        Default initialization. User has called RANMAR without RMARIN.
      IJKL = 54217137
      NTOT = 0
      NTOT2 = 0
      KALLED = 0
      GO TO 1
C
      ENTRY      RMARIN(IJKLIN, NTOTIN,NTOT2N)
C         Initializing routine for RANMAR, may be called before
C         generating pseudorandom numbers with RANMAR. The input
C         values should be in the ranges:  0<=IJKLIN<=900 OOO OOO
C                                          0<=NTOTIN<=999 999 999
C                                          0<=NTOT2N<<999 999 999!
C To get the standard values in Marsaglia-s paper, IJKLIN=54217137
C                                            NTOTIN,NTOT2N=0
      IJKL = IJKLIN
      NTOT = MAX(NTOTIN,0)
      NTOT2= MAX(NTOT2N,0)
      KALLED = 1
C          always come here to initialize
    1 CONTINUE
      IJ = IJKL/30082
      KL = IJKL - 30082*IJ
      I = MOD(IJ/177, 177) + 2
      J = MOD(IJ, 177)     + 2
      K = MOD(KL/169, 178) + 1
      L = MOD(KL, 169)
      WRITE(IOUT,201) IJKL,NTOT,NTOT2
 201  FORMAT(1X,' RANMAR INITIALIZED: ',I10,2X,2I10)
      DO 2 II= 1, 97
      S = 0.
      T = .5
      DO 3 JJ= 1, 24
         M = MOD(MOD(I*J,179)*K, 179)
         I = J
         J = K
         K = M
         L = MOD(53*L+1, 169)
         IF (MOD(L*M,64) .GE. 32)  S = S+T
    3    T = 0.5*T
    2 U(II) = S
      TWOM24 = 1.0
      DO 4 I24= 1, 24
    4 TWOM24 = 0.5*TWOM24
      C  =   362436.*TWOM24
      CD =  7654321.*TWOM24
      CM = 16777213.*TWOM24
      I97 = 97
      J97 = 33
C       Complete initialization by skipping
C            (NTOT2*MODCNS + NTOT) random numbers
      DO 45 LOOP2= 1, NTOT2+1
      NOW = MODCNS
      IF (LOOP2 .EQ. NTOT2+1)  NOW=NTOT
      IF (NOW .GT. 0)  THEN
       WRITE (IOUT,'(A,I15)') ' RMARIN SKIPPING OVER ',NOW
       DO 40 IDUM = 1, NTOT
       UNI = U(I97)-U(J97)
       IF (UNI .LT. 0.)  UNI=UNI+1.
       U(I97) = UNI
       I97 = I97-1
       IF (I97 .EQ. 0)  I97=97
       J97 = J97-1
       IF (J97 .EQ. 0)  J97=97
       C = C - CD
       IF (C .LT. 0.)  C=C+CM
   40  CONTINUE
      ENDIF
   45 CONTINUE
      IF (KALLED .EQ. 1)  RETURN
C
C          Normal entry to generate LENV random numbers
   50 CONTINUE
      DO 100 IVEC= 1, LENV
      UNI = U(I97)-U(J97)
      IF (UNI .LT. 0.)  UNI=UNI+1.
      U(I97) = UNI
      I97 = I97-1
      IF (I97 .EQ. 0)  I97=97
      J97 = J97-1
      IF (J97 .EQ. 0)  J97=97
      C = C - CD
      IF (C .LT. 0.)  C=C+CM
      UNI = UNI-C
      IF (UNI .LT. 0.) UNI=UNI+1.
C        Replace exact zeroes by uniform distr. *2**-24
         IF (UNI .EQ. 0.)  THEN
         UNI = TWOM24*U(2)
C             An exact zero here is very unlikely, but lets be safe.
         IF (UNI .EQ. 0.) UNI= TWOM24*TWOM24
         ENDIF
      RVEC(IVEC) = UNI
  100 CONTINUE
      NTOT = NTOT + LENV
         IF (NTOT .GE. MODCNS)  THEN
         NTOT2 = NTOT2 + 1
         NTOT = NTOT - MODCNS
         ENDIF
      RETURN
C           Entry to output current status
      ENTRY RMARUT(IJKLUT,NTOTUT,NTOT2T)
      IJKLUT = IJKL
      NTOTUT = NTOT
      NTOT2T = NTOT2
      RETURN
      END







