      PROGRAM TESTERDEM
C     *****************

C===============================
C initialization of MC-TESTER  =
C===============================
C we'll use HEPEVT: 
      CALL MCSETUP(0,0)
C decay of tau- PDG=15
!      CALL MCSETUP(2,15) 
      CALL MCSETUP(2,100) 
C  generation stage (generator id): 1
      CALL MCSETUP(1,1)
C Histograms set-up:
C 120 bins per histogram     
      CALL MCSETUPHBINS(120)
C default minimum bin value is 0.0D0
      CALL MCSETUPHMIN(0.0D0)
C default maximum bin value is 90.0D0 (1.5 times cms energy for w-shop.
      CALL MCSETUPHMAX(90D0)

C execute initialization of  MC-Tester
      CALL MCTEST(-1)
C======================================
C end of initialization of MC-TESTER  =
C======================================

C Here come calls to your programs, just running in this case.
      CALL TESTES

C finalization of MC-TESTER actions:
      CALL MCTEST(1)
      END


      SUBROUTINE TESTES
C     *****************

      NEVTES=1 
 
      DO 300 IEV=1,NEVTES

         CALL PSEUDOEVENT            !  pseudo_generator
         IF (IEV.eq.1) call phodmpts ! how the hepevt is filled ?
         CALL MCTEST(0)              ! MC-TESTER is called
 
  300 CONTINUE

      RETURN
      END
      
      SUBROUTINE PSEUDOEVENT
C     ======================
C     This PSEUDOEVENT can need fill of HEPEVT with up to 8 final
C     state fermions. The TOHEPI routine should work with any
C     of these cases, as well as with your programs 
      DIMENSION  XPB1(4),XPB2(4),AQF1(4),AQF2(4)
      DIMENSION   AQF3(4),AQF4(4) ,AQF5(4),AQF6(4)  ,AQF7(4),AQF8(4) 

C      IN FINAL STATE THERE ARE N PARTICLES .... 
        N=6

!      Some of them may be dummy

C HERE COME THEIR IDENTIFIERS, ACCORDINGLY TO PARTICLE DATA GROUP CONVENTIONS
C JUST IN CASE WE FILL VALUES FOR 8 FINAL STATESBUT ONLY FIRST N WILL BE USED.

C beams ...
        KFB1= 11
        KFB2=-11

C final states ...

        IDF1= 13
        IDF2=-13
        IDF3= 12
        IDF4=-12
        IDF5= 14
        IDF6=-14
        IDF7= 15
        IDF8=-15

C MOMENTA OF THE BEAMS:
        XPB1(1)= 0.
        XPB2(1)= 0.
        XPB1(2)= 0.
        XPB2(2)= 0.
        XPB1(3)= 5.*N
        XPB2(3)=-5.*N 
        XPB1(4)= 5.*N
        XPB2(4)= 5.*N 

C MOMENTA OF THE FIRST PAIR OF FERMIONS:
        AQF1(1)= 0.
        AQF2(1)= 0.
        AQF1(2)= 0.
        AQF2(2)= 0.
        AQF1(3)= 10.
        AQF2(3)=-10.
        AQF1(4)= 10.
        AQF2(4)= 10.

C MOMENTA OF THE SECOND PAIR OF FERMIONS:
        AQF3(1)= 10.
        AQF4(1)=-10.
        AQF3(2)= 0.
        AQF4(2)= 0.
        AQF3(3)= 0.
        AQF4(3)= 0.
        AQF3(4)= 10.
        AQF4(4)= 10.

C MOMENTA OF THE THIRD PAIR OF FERMIONS:
        AQF5(1)= 0.
        AQF6(1)= 0.
        AQF5(2)= 10.
        AQF6(2)=-10.
        AQF5(3)= 0.
        AQF6(3)= 0.
        AQF5(4)= 10.
        AQF6(4)= 10.

C MOMENTA OF THE FOURTH PAIR OF FERMIONS:
        AQF7(1)= 5.
        AQF8(1)=-5.
        AQF7(2)= 5.
        AQF8(2)=-5.
        AQF7(3)= 0.
        AQF8(3)= 0.
        AQF7(4)= 10.
        AQF8(4)= 10.
       
      CALL TOHEPI(N,KFB1,KFB2,
     $ IDF1,IDF2,IDF3,IDF4,IDF5,IDF6,IDF7,IDF8,
     $ XPB1,XPB2,AQF1,AQF2,AQF3,AQF4,AQF5,AQF6,AQF7,AQF8)

      END


      SUBROUTINE TOHEPI(N,KFB1,KFB2,
     $ IDF1,IDF2,IDF3,IDF4,IDF5,IDF6,IDF7,IDF8,
     $ XPB1,XPB2,AQF1,AQF2,AQF3,AQF4,AQF5,AQF6,AQF7,AQF8)
C     ===================================================
C     THIS IS THE ROUTINE YOU WILL USE:
C     N             - number of particles in final state
C     KFB1,KFB2     - beam identifiers
C     IDF1,IDF2,... - identifiers of FS particles 
C     XPB1,XPB2,... - beam four momenta
C     AQF1,AQF2,... - final state partcls four momenta
C     IDFn,AQFn     - for n.GT.N are dummy
C     ===================================================
      DIMENSION  XPB1(4),XPB2(4),AQF1(4),AQF2(4)
      DIMENSION  AQF3(4),AQF4(4),AQF5(4),AQF6(4),AQF7(4),AQF8(4) 

C CALCULATING MASSES AND WRITING DOWN TO EVENT RRRECORD: BEAMS:

      AMEL=SQRT(ABS(XPB1(4)**2-XPB1(3)**2-XPB1(2)**2-XPB1(1)**2))   
      CALL FYLHEP(  1,3, KFB1,0,0,0,0,XPB1, AMEL,.TRUE.)

      AMEL=SQRT(ABS(XPB2(4)**2-XPB2(3)**2-XPB2(2)**2-XPB2(1)**2)) 
      CALL FYLHEP(  2,3, KFB2,0,0,0,0,XPB2, AMEL,.TRUE.)

C=============================================================
C THE SAME FOR FINAL STATES (UP TO N ENTRY)

      AMTAU=SQRT(ABS(AQF1(4)**2-AQF1(3)**2-AQF1(2)**2-AQF1(1)**2))
      CALL FYLHEP(  3,1, IDF1,1,2,0,0,AQF1,AMTAU,.TRUE.)

      AMTAU=SQRT(ABS(AQF2(4)**2-AQF2(3)**2-AQF2(2)**2-AQF2(1)**2))
      CALL FYLHEP(  4,1,IDF2,1,2,0,0,AQF2,AMTAU,.TRUE.)
      IF(N.EQ.2) RETURN

      AMTAU=SQRT(ABS(AQF3(4)**2-AQF3(3)**2-AQF3(2)**2-AQF3(1)**2))
      CALL FYLHEP(  5,1, IDF3,1,2,0,0,AQF3,AMTAU,.TRUE.)
      IF(N.EQ.3) RETURN

      AMTAU=SQRT(ABS(AQF4(4)**2-AQF4(3)**2-AQF4(2)**2-AQF4(1)**2))
      CALL FYLHEP(  6,1,IDF4,1,2,0,0,AQF4,AMTAU,.TRUE.)
      IF(N.EQ.4) RETURN

      AMTAU=SQRT(ABS(AQF5(4)**2-AQF5(3)**2-AQF5(2)**2-AQF5(1)**2))
      CALL FYLHEP(  7,1, IDF5,1,2,0,0,AQF5,AMTAU,.TRUE.)
      IF(N.EQ.5) RETURN

      AMTAU=SQRT(ABS(AQF6(4)**2-AQF6(3)**2-AQF6(2)**2-AQF6(1)**2))
      CALL FYLHEP(  8,1,IDF6,1,2,0,0,AQF6,AMTAU,.TRUE.)
      IF(N.EQ.6) RETURN

      AMTAU=SQRT(ABS(AQF7(4)**2-AQF7(3)**2-AQF7(2)**2-AQF7(1)**2))
      CALL FYLHEP(  9,1, IDF7,1,2,0,0,AQF7,AMTAU,.TRUE.)
      IF(N.EQ.7) RETURN

      AMTAU=SQRT(ABS(AQF8(4)**2-AQF8(3)**2-AQF8(2)**2-AQF8(1)**2))
      CALL FYLHEP( 10,1,IDF8,1,2,0,0,AQF8,AMTAU,.TRUE.)


      END


      SUBROUTINE PHODMPTS
C.----------------------------------------------------------------------
C.
C.    PHOTOS:   PHOton radiation in decays event DuMP routine
C.
C.    Purpose:  Print event record.
C.
C.    Input Parameters:   Common /HEPEVT/
C.
C.    Output Parameters:  None
C.
C.    Author(s):  B. van Eijk                     Created at:  05/06/90
C.                                                Last Update: 05/06/90
C.
C.----------------------------------------------------------------------
C      IMPLICIT NONE
      DOUBLE PRECISION  SUMVEC(5)
      INTEGER I,J
C this is the hepevt class in old style. No d_h_ class pre-name
      INTEGER NMXHEP
      PARAMETER (NMXHEP=4000)
      REAL*8  phep,  vhep ! to be real*4/ *8  depending on host
      INTEGER nevhep,nhep,isthep,idhep,jmohep,
     $        jdahep
      COMMON /hepevt/
     $      nevhep,               ! serial number
     $      nhep,                 ! number of particles
     $      isthep(nmxhep),   ! status code
     $      idhep(nmxhep),    ! particle ident KF
     $      jmohep(2,nmxhep), ! parent particles
     $      jdahep(2,nmxhep), ! childreen particles
     $      phep(5,nmxhep),   ! four-momentum, mass [GeV]
     $      vhep(4,nmxhep)    ! vertex [mm]
* ----------------------------------------------------------------------
      LOGICAL qedrad
      COMMON /phoqed/ 
     $     qedrad(nmxhep)    ! Photos flag
* ----------------------------------------------------------------------
      SAVE hepevt,phoqed



      INTEGER PHLUN
      COMMON/PHOLUN/PHLUN
      DO 10 I=1,5
   10 SUMVEC(I)=0.
C--
C--   Print event number...
      WRITE(PHLUN,9000)
      WRITE(PHLUN,9010) NEVHEP
      WRITE(PHLUN,9080)
      WRITE(PHLUN,9020)
      DO 30 I=1,NHEP
C--
C--   For 'stable particle' calculate vector momentum sum
        IF (JDAHEP(1,I).EQ.0) THEN
          DO 20 J=1,4
   20     SUMVEC(J)=SUMVEC(J)+PHEP(J,I)
          IF (JMOHEP(2,I).EQ.0) THEN
            WRITE(PHLUN,9030) I,IDHEP(I),JMOHEP(1,I),(PHEP(J,I),J=1,5)
          ELSE
            WRITE(PHLUN,9040) I,IDHEP(I),JMOHEP(1,I),JMOHEP(2,I),(PHEP
     &      (J,I),J=1,5)
          ENDIF
        ELSE
          IF (JMOHEP(2,I).EQ.0) THEN
            WRITE(PHLUN,9050) I,IDHEP(I),JMOHEP(1,I),JDAHEP(1,I),
     &      JDAHEP(2,I),(PHEP(J,I),J=1,5)
          ELSE
            WRITE(PHLUN,9060) I,IDHEP(I),JMOHEP(1,I),JMOHEP(2,I),
     &      JDAHEP(1,I),JDAHEP(2,I),(PHEP(J,I),J=1,5)
          ENDIF
        ENDIF
   30 CONTINUE
      SUMVEC(5)=SQRT(SUMVEC(4)**2-SUMVEC(1)**2-SUMVEC(2)**2-
     &SUMVEC(3)**2)
      WRITE(PHLUN,9070) (SUMVEC(J),J=1,5)
      RETURN
 9000 FORMAT(1H0,80('='))
 9010 FORMAT(1H ,29X,'Event No.:',I10)
 9020 FORMAT(1H0,1X,'Nr',3X,'Type',3X,'Parent(s)',2X,'Daughter(s)',6X,
     &'Px',7X,'Py',7X,'Pz',7X,'E',4X,'Inv. M.')
 9030 FORMAT(1H ,I4,I7,3X,I4,9X,'Stable',2X,5F9.2)
 9040 FORMAT(1H ,I4,I7,I4,' - ',I4,5X,'Stable',2X,5F9.2)
 9050 FORMAT(1H ,I4,I7,3X,I4,6X,I4,' - ',I4,5F9.2)
 9060 FORMAT(1H ,I4,I7,I4,' - ',I4,2X,I4,' - ',I4,5F9.2)
 9070 FORMAT(1H0,23X,'Vector Sum: ', 5F9.2)
 9080 FORMAT(1H0,6X,'Particle Parameters')
      END

      SUBROUTINE FYLHEP(N,IST,ID,JMO1,JMO2,JDA1,JDA2,P4,PINV,PHFLAG)
C ----------------------------------------------------------------------
C this subroutine fills one entry into the HEPEVT common
C and updates the information for affected mother entries
C
C written by Martin W. Gruenewald (91/01/28)
C
C     called by : ZTOHEP,BTOHEP,DWLUxy
C ----------------------------------------------------------------------
C
C this is the hepevt class in old style. No d_h_ class pre-name
      INTEGER NMXHEP
      PARAMETER (NMXHEP=4000)
      REAL*8  phep,  vhep ! to be real*4/ *8  depending on host
      INTEGER nevhep,nhep,isthep,idhep,jmohep,
     $        jdahep
      COMMON /hepevt/
     $      nevhep,               ! serial number
     $      nhep,                 ! number of particles
     $      isthep(nmxhep),   ! status code
     $      idhep(nmxhep),    ! particle ident KF
     $      jmohep(2,nmxhep), ! parent particles
     $      jdahep(2,nmxhep), ! childreen particles
     $      phep(5,nmxhep),   ! four-momentum, mass [GeV]
     $      vhep(4,nmxhep)    ! vertex [mm]
* ----------------------------------------------------------------------
      LOGICAL qedrad
      COMMON /phoqed/ 
     $     qedrad(nmxhep)    ! Photos flag
* ----------------------------------------------------------------------
      SAVE hepevt,phoqed



C      PARAMETER (NMXHEP=2000)
C      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
C     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
C      SAVE  /HEPEVT/
C      COMMON/PHOQED/QEDRAD(NMXHEP)
C      LOGICAL QEDRAD
C      SAVE /PHOQED/
      LOGICAL PHFLAG
C
      REAL*4  P4(4)
C
C check address mode
      IF (N.EQ.0) THEN
C
C append mode
        IHEP=NHEP+1
      ELSE IF (N.GT.0) THEN
C
C absolute position
        IHEP=N
      ELSE
C
C relative position
        IHEP=NHEP+N
      END IF
C
C check on IHEP
      IF ((IHEP.LE.0).OR.(IHEP.GT.NMXHEP)) RETURN
C
C add entry
      NHEP=IHEP
      ISTHEP(IHEP)=IST
      IDHEP(IHEP)=ID
      JMOHEP(1,IHEP)=JMO1
      IF(JMO1.LT.0)JMOHEP(1,IHEP)=JMOHEP(1,IHEP)+IHEP
      JMOHEP(2,IHEP)=JMO2
      IF(JMO2.LT.0)JMOHEP(2,IHEP)=JMOHEP(2,IHEP)+IHEP
      JDAHEP(1,IHEP)=JDA1
      JDAHEP(2,IHEP)=JDA2
C
      DO I=1,4
        PHEP(I,IHEP)=P4(I)
C
C KORAL-B and KORAL-Z do not provide vertex and/or lifetime informations
        VHEP(I,IHEP)=0.0
      END DO
      PHEP(5,IHEP)=PINV
C FLAG FOR PHOTOS...
      QEDRAD(IHEP)=PHFLAG
C
C update process:
      DO IP=JMOHEP(1,IHEP),JMOHEP(2,IHEP)
        IF(IP.GT.0)THEN
C
C if there is a daughter at IHEP, mother entry at IP has decayed
          IF(ISTHEP(IP).EQ.1)ISTHEP(IP)=2
C
C and daughter pointers of mother entry must be updated
          IF(JDAHEP(1,IP).EQ.0)THEN
            JDAHEP(1,IP)=IHEP
            JDAHEP(2,IP)=IHEP
          ELSE
            JDAHEP(2,IP)=MAX(IHEP,JDAHEP(2,IP))
          END IF
        END IF
      END DO
C
      RETURN
      END





